#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.1.0
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-dbus
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python3-rpm-macros

Requires:   python%{python3_pkgversion}
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0-linux < 4.1.0

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
export BACKEND_VMM=xen
make all-base
#make -C doc PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    DESTDIR=$RPM_BUILD_ROOT

#make -C doc DESTDIR=$RPM_BUILD_ROOT \
#    PYTHON=%{__python3} SPHINXBUILD=sphinx-build-%{python3_version} \
#    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qubes-policy
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client_dom0.py
%{python3_sitelib}/qrexec/client_vm.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/api.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_api.py
%{python3_sitelib}/qrexec/tests/policy_parser.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/PolicyCreateConfirmationWindow.glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Sat Jun 08 2019 Qubes OS Team <qubes-devel@groups.google.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec

* Sat Jun 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0a8b49e
- rpm: fix build with mock

* Thu Jun 06 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ac8b046
- Merge branch 'qrexec-agent-restart'

* Mon Jun 03 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 630709b
- agent,daemon: allocate data buffers on the heap

* Mon Jun 03 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ae77f4
- Bump protocol version to 3

* Mon Jun 03 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 93960fb
- Allow longer qrexec service names and arguments

* Mon Jun 03 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cc4ddf5
- agent,daemon: increase data chunk size to 64k in protocol 3

* Thu May 30 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 65d48e6
- dom0: when qrexec-agent disconnects, try to reconnect

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 19b0142
- Add protocol version enum, with protocol changelog

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e124178
- daemon: save negotiated protocol version

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d1f4a7a
- daemon: use 1-byte buffer for EOF checking

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7ca22dc
- libqrexec: remove arbitrary chunk size limit in flush_client_data

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 588efaa
- libqrexec: wrap includes in #ifndef

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 556f7e4
- agent: fix size_t handling

* Sat May 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b4d3f02
- makefile: fix building from git checkout

* Sun Apr 21 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c70c213
- qrexec-policy: use default_target in policy prompt

* Sun Apr 21 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8a3fc64
- dom0: qrexec-client: recognise @adminvm as dom0

* Fri Apr 19 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f9e638d
- travis: set default python version to 3.5

* Fri Apr 19 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f86c34f
- Revert to the old parameter order for qrexec-policy-exec

* Fri Apr 19 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 08ed600
- qubespolicy: fix default target if it's a keyword

* Thu Apr 18 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e70b507
- qubespolicy: forbid qrexec loopback connections at policy level

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4bbc997
- tests: mock qrexec.call when running outside of qubes

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 734146c
- Fix compat parser - missing collect_targets_for_ask

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 753fe48
- tests: skip not migrated tests

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8e7dc31
- Make pylint happy

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 94d5151
- rpm: adjust python3 package name for CentOS compat

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 22c804f
- debian: add new tools to package

* Mon Apr 15 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4da1366
- travis: add tests, pylint, codecov and centos7

* Sun Apr 14 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6dc5e2c
- Merge remote-tracking branch 'origin/pr/2'

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e91a93d
- rpm: add BR: pandoc

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0f1536c
- Remove unused makefile fragment

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9dbca2c
- Adjust python code to renamed module qubespolicy -> qrexec

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7294f52
- Add qrexec policy agent startup files

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 06b66f9
- Include documentation for things moved from core-admin

* Sat Apr 13 2019 fepitre <frederic.epitre@orange.fr> - c2b93a9
- Fix GCC8 warning

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - de34d98
- qrexec: add version negotiation

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e5aa33b
- debian: add packaging

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2c9f3ad
- Fix issues pointed by -Wunused-result

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - eb50cef
- Fix makefiles to work outside of rpm build too

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - af86447
- Add /etc/qubes/rpc-config/README

* Sat Apr 13 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5be8a14
- rpm: rework packaging

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9257c21
- rpm: fix source directory name

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9b46265
- travis: initial version

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1c0b958
- qrexec: add version negotiation

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 14289a9
- qrexec: add startup notification

* Fri Apr 05 2019 unman <unman@thirdeyesecurity.org> - 6e185d8
- Install debian version of qrexec pam in Ubuntu templates

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7d85551
- rpm: use build flags provided by the distribution

* Fri Apr 05 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d01b857
- qrexec: fix handling remote domain death

* Wed Apr 03 2019 Wojtek Porczyk <woju@invisiblethingslab.com> - b74dd84
- qrexec: test for implicit deny rule in !compat-4.0 and bugfix

* Tue Apr 02 2019 Wojtek Porczyk <woju@invisiblethingslab.com> - 4da62c7
- A simple test for !compat-4.0 statement

* Tue Apr 02 2019 Wojtek Porczyk <woju@invisiblethingslab.com> - aea65e9
- Update documentation

